;;; setup file for cl-bench running in MCL
;;
;; contributed by James Anderson
;;
;;
;; You may need to increase the heap size allocated for MCL. 96 MB is
;; reported to be sufficient.


(load "development:source;cl-bench;defpackage")
(in-package :cl-bench)

(defun bench-gc () (ccl:gc))

(defmacro with-spawned-thread (&body body)
  `(progn ,@body))

;; to ignore comments in Unix-encoded source files
(set-macro-character #\;
                     #'(lambda (stream char)
                         (loop (unless (setf char (read-char stream nil nil)) (return))
                               (when (member char '(#\return #\linefeed)) (return)))
                         (values)))

(setf (logical-pathname-translations "cl-bench")
      `(("**;*.*" ,(make-pathname :directory `(,@(butlast (pathname-directory *load-pathname*)) :wild-inferiors)
                                  :name :wild :type :wild))))


;; disabled by Eric Marsden; I consider this to be cheating
#+nil (setq ccl::*CHECK-SLOT-TYPE* nil)

;; EOF
